<h4>Formularios <small>Reactivo</small></h4>
<hr>

<div class="container">
  <form [formGroup]="forma" (ngSubmit)="guardar()">

    <div class="row">
      <div class="col-5">
        <label for="fname" class="lbl">Nombre</label>
      </div>
      <div>
        <input 
        type="text"
        id="fname"
        placeholder="Nombre"
        class="txtbox"
        formControlName="nombre"
        [class.is-invalid] = "nombreNoValido"
        >
        <small class="text-danger" *ngIf="nombreNoValido">Ingrese más de 3 letras</small>
      </div>
    </div>
    <div class="row">
      <div class="col-5">
        <label for="flastName" class="lbl">Apellido</label>
      </div>
      <div>
        <input 
        type="text"
        id="flastName"
        placeholder="Apellido"
        class="txtbox"
        formControlName="apellido"
        [class.is-invalid] = "apellidoNoValido"
        >
        <small class="text-danger" *ngIf="apellidoNoValido">
          Ingrese más de 3 letras
        </small>
        <small class="text-danger" *ngIf="apellidoNoZaralai">
          No se puede ingresar el apellido Zaralai
        </small>
      </div>
    </div>

    <div class="row">
      <div class="col-5">
        <label for="femail" class="lbl">Email</label>
      </div>
      <div>
        <input 
        type="text"
        id="femail"
        placeholder="Correo Electrónico"
        class="txtbox"
        formControlName="correo"
        [class.is-invalid] = "correoNoValido" 
        >
        <small class="text-danger" *ngIf="correoNoValido">Ingrese un correo válido</small>
      </div>
    </div>

    <div class="row">
      <div class="col-5">
        <label for="fusuario" class="lbl">Usuario</label>
      </div>
      <div>
        <input type="text"
        id="fusuario"
        placeholder="Nombre de Usuario"
        class="txtbox"
        formControlName="usuario"
        [class.is-invalid]="usuarioNoValido"
        >
        <small class="text-danger" *ngIf="usuarioNoValido">
          Ingrese un nombre de usuario
        </small>
        <small class="text-danger" *ngIf="usuarioIgualJerjer">
          El nombre de usuario ya esta en uso
        </small>
      </div>
    </div>

    <div class="row">
      <div class="col-5">
        <label for="fpassword" class="lbl">Contraseña</label>
      </div>
      <div>
        <input 
        type="password"
        id="fpassword"
        placeholder="Contraseña"
        class="txtbox"
        formControlName="pass1"
        [class.is-invalid] = "pass1NoValido"
        >
      </div>
    </div>

    <div class="row">
      <div class="col-5">
        <label for="fpassword2" class="lbl">Repita</label>
      </div>
      <div>
        <input 
        type="password"
        id="fpassword2"
        placeholder="Contraseña"
        class="txtbox"
        formControlName="pass2"
        [class.is-invalid] = "pass2NoValido"
        >
      </div>
    </div>


    <div class="row" formGroupName="direccion">
      <div class="col-5">
        <label class="lbl">Dirección</label>
      </div>
      <div>
        <input 
        type="text"
        placeholder="Distrito"
        class="txtbox-2 mueve-derecha"
        formControlName="distrito"
        [class.is-invalid]="distritoNoValido"
        >
      </div>
      <div>
        <input 
        type="text"
        placeholder="Ciudad"
        class="txtbox-2 mueve-derecha"
        formControlName="ciudad"
        [class.is-invalid]="ciudadNoValid"
        >
      </div>
      <div>
        <small class="text-danger" *ngIf="distritoNoValido">El distrito es obligatorio</small>
        <small class="text-danger" *ngIf="ciudadNoValid">La ciudad es obligatoria</small>
      </div>
    
    </div>

      <div class="tamano-tabla row">
        <table>
          <thead class="color-cabecera">
            <tr>
            <th>ID</th>
            <th>Pasatiempo</th>
            <th>Borrar</th>
            </tr>
          </thead>
          <tbody formArrayName="pasatiempos">
              <tr *ngFor="let s of pasatiemposO.controls; let i = index ">
                <td>{{ i + 1 }}</td>
                <td><input type="text" class="txtbox-table" [formControlName]="i"></td>
                <td>
                  <button type="button" class="btn-danger" (click)="borrarPasatiempo(i)">Borrar</button>
                </td>
              </tr>
            </tbody>
        </table>

        <br>
        <button class="btn-add" type="button" (click)="agregarpasatiempo()">
          Agregar
        </button>
        </div>
        

    <div class="row">
      <div class="alinea-btn">
        <button type="submit" class="btn" [disabled]="forma.invalid">Guardar</button>
      </div>
    </div>
  </form>
</div>

<!--
Esto lo hicimos para monitorear el formulario
No mostrar en la consola, porque eso lo puede ver cualquiera
-->
<hr>
<pre>
  Estado del formulario: {{ forma.valid }}
  <br>
  Status: {{ forma.status }} 
  <!-- En status se tiene si es invalido o valido -->
</pre>
<pre>
  {{ forma.value | json}} <!--se le hizo un pipe-->
</pre>